import { LitElement } from 'lit-element';
import { DomTools } from './domtools.classes.domtools';
import * as plugins from './domtools.plugins';

export class ThemeManager {
  public domtoolsRef: DomTools;
  
  goBrightBoolean = false;

  constructor(domtoolsRefArg: DomTools) {
    this.domtoolsRef = domtoolsRefArg;
    this.domtoolsRef.elementInstrumenter.connectedElements.eventSubject.subscribe(async eventData => {
      await this.setThemeStatusForElement(eventData.payload, this.goBrightBoolean);
    });
  }

  private async setThemeStatusForElement (elementArg: LitElement, goBrightBool: boolean) {
    const goBright = (elementArg as any).goBright;
    if (typeof goBright === 'boolean') {
      (elementArg as any).goBright = goBrightBool;
    }
  }

  public goBright() {
    this.domtoolsRef.elementInstrumenter.forEachelement(async elementArg => {
      await this.setThemeStatusForElement(elementArg, true);
    });
  }

  public goDark() {
    this.domtoolsRef.elementInstrumenter.forEachelement(async elementArg => {
      await this.setThemeStatusForElement(elementArg, false);
    });
  }
}